program chess_basic;
const
    ai_player=1;
    human_player=2;
    black=222;
    white=223;
global
    depth=3;
    //search depth (look ahead)
    //a depth of 3 is equivilant to AI move,Player move,Ai move

    bpiece_graph[5]=8,10,6,4,2,12;
    wpiece_graph[5]=9,11,7,5,3,13;
    sx[63];
    sy[63];
    fnt1;

    chessboard[63];//these tables are also used by the DLL
    has_moved[32];
    sqrs[32];
    piece_type[32];

    move_side=white;//whos go it is

    import "chess.dll";
begin
    set_fps(60,0);
    set_mode(m800x600);
    load_fpg("c:\div\chess.fpg");
    fnt1=load_fnt("c:\div\chess.fnt");
    mouse.graph=14;
    chess_init();//DLL must be initialised
    game(human_player,ai_player);
    //play as Human white against AI black
end

process game(pwhite,pblack)
begin
move_side=white;
chess_new_board();
show_board();
frame;
loop
    if(chess_is_checkmate(move_side))
        if(move_side==white)
            for(x=0;x<130;x++)
            frame;end
            say("Black wins! Checkmate.");
        else
            for(x=0;x<130;x++)
            frame;end
            say("White wins! Checkmate.");
        end
        loop
        frame;end
    end
    while(mouse.left)
    frame;end
    show_board();
    loop
        saveload();
        while(key(_s) or key(_l))
        frame;end
        if(mouse.left && not key(_space))
            x=mouse_square();
            marker(x);
            for(y=0;y<64;y++)
                if(chess_valid_move(move_side,x,y))
                    marker(y);
                end
            end
            while(mouse.left)
            frame;end
            repeat
            frame;until(mouse.left or scan_code<>0)
            signal(type marker,s_kill);
        if(chess_valid_move(move_side,x,mouse_square()));
            chess_move_piece(x,mouse_square());
            x=mouse_square();
            if(chess_can_promote(chess_get_piece(x)))
                show_board();
                while(mouse.left)
                frame;end
                promote(move_side,chess_get_piece(x));
                while(get_id(type promote)<>0)
                frame;end
            end
            break;
        end
        end
        if(pwhite==ai_player && move_side==white)
            chess_ai_move(move_side,depth);
            break;
        end
        if(pblack==ai_player && move_side==black)
            chess_ai_move(move_side,depth);
            break;
        end
    frame;end
    show_board();
    while(mouse.left)
    frame;end
    show_board();
    move_side=chess_other_side(move_side);
frame;end
end

process saveload()
begin
        if(key(_s))
            while(key(_s))
            frame;end
            chess_get_board(&chessboard,&has_moved,&sqrs,&piece_type);
            save("chessboA.sav",&chessboard,sizeof(chessboard));
            save("chessboB.sav",&has_moved,sizeof(has_moved));
            save("chessboC.sav",&depth,sizeof(depth));
            save("chessboD.sav",&sqrs,sizeof(sqrs));
            save("chessboE.sav",&piece_type,sizeof(piece_type));
            save("chessboF.sav",&move_side,sizeof(move_side));
            mess("Game Saved",400,300);
        end
        if(key(_l))
            while(key(_l))
            frame;end
            load("chessboA.sav",&chessboard);
            load("chessboB.sav",&has_moved);
            load("chessboC.sav",&depth);
            load("chessboD.sav",&sqrs);
            load("chessboE.sav",&piece_type);
            load("chessboF.sav",&move_side);
            chess_set_board(&chessboard,&has_moved,&sqrs,&piece_type);
            show_board();
            mess("Game Loaded",400,300);
        end
end

process show_board()
begin
chess_get_board(&chessboard,&has_moved,&sqrs,&piece_type);
clear_screen();
put_screen(0,1);
y=37;
for(z=0;z<8;z++)
x=49;
for(height=0;height<8;height++)
angle=(z*8)+height;
sx[angle]=x;
sy[angle]=y;
if(chessboard[angle]<>0)
    if(chess_get_side(angle)==white)
        put(0,wpiece_graph[chess_get_piece_type(angle)-101],x,y);
    else
        put(0,bpiece_graph[chess_get_piece_type(angle)-101],x,y);
    end
end
x+=100;
end
y+=75;
end
end

process say(text)
begin
let_me_alone();
delete_text(all_text);
write(fnt1,400,300,4,text);
write(fnt1,400,400,4,"(thanx 4 playing DTM chess)");
while(mouse.left or key(_esc))
frame;end
while(not mouse.left and not key(_esc))
frame;end
exit("See ya!",0);
end

process mess(text,x,y)
begin
delete_text(all_text);
z=write(fnt1,x,y,4,text);
for(x=0;x<200;x++)
    if(mouse.left)
        break;
    end
frame;end
delete_text(z);
end

process promote(side,piece)
private
    a;
begin
x=400;
if(side==white)
    graph=22;
end
if(side==black)
    graph=23;
end
mess("Promote Pawn!",400,500);
seller();
loop
    y=mouse.y;
    a=((mouse.x-100)/100)+101;
    if(a>101 && a<106)
        son.x=150+(a-101)*100;
        if(mouse.left)
            signal(type seller,s_kill);
            chess_promote(piece,a);
            break;
        end
    else
        son.x=-1000;
    end
frame;end
end

process seller()//piece selection graphic for pawn promotion
begin
graph=16;
flags=4;
while(father<>get_id(0))
    y=mouse.y;
frame;end
end

process mouse_square()//returns the square that mouse is over
begin
    return(((mouse.y/75)*8)+(mouse.x/100));
end

process marker(a);//puts a marker graphic over square A
begin
flags=4;
graph=16;
x=sx[a];
y=sy[a];
loop
frame;end
end